
import fi.helsinki.cs.tmc.edutestutils.MockStdio;
import fi.helsinki.cs.tmc.edutestutils.Points;
import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;
import org.junit.Rule;
import org.junit.Test;

@Points("12-06")
public class NumbersTest {

    @Rule
    public MockStdio io = new MockStdio();

    @Test
    public void test1() {
        io.setSysIn("5\n");
        try {
            Program.main(new String[]{});
        } catch (Throwable t) {

        }

        List<Integer> numbers = numbers();
        assertEquals("When the input is 5 there should be 5 numbers in the output. Now there were " + numbers.size() + " numbers.\nThe numbers were: " + numbers, 5, numbers.size());
    }

    @Test
    public void test2() {
        io.setSysIn("100000\n");
        try {
            Program.main(new String[]{});
        } catch (Throwable t) {

        }

        List<Integer> numbers = numbers();
        for (int i = 0; i <= 10; i++) {
            assertTrue("The number " + i + " should appear in the numbers generated by the program", numbers.contains(i));
        }

        assertFalse("The number -1 should not appear in the numbers generated by the program.", numbers.contains(-1));
        assertFalse("The number 11 should not appear in the numbers generated by the program.", numbers.contains(11));
    }

    private List<Integer> numbers() {
        return Arrays.stream(io.getSysOut().split("\n"))
                .filter(l -> l.replaceAll("[^\\d]", "").equals(l))
                .map(l -> Integer.parseInt(l))
                .collect(Collectors.toList());
    }
}
